*
* AUTO.PRG
*
* Visual dBase "AUTO" program.
*
* This program uses two channels concurrently to automatically respond
* to all email waiting on the POP3 server.
*

#INCLUDE C:\TEMP\SEE32.CC
#INCLUDE C:\TEMP\KEYCODE.CC

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
SmtpServer = "10.0.0.1"
SmtpFrom = "<mike@10.0.0.1>"
SmtpReply = ""
Message = "Your email has been received."
Subject = "Automated Response"
Pop3File = "C:\TEMP\autopop3.log"
SmtpFile = "C:\TEMP\autosmtp.log"
*** END PROGRAMMER ***

? "AUTO 02/16/2000"

ReplyToText = "Reply-To: "
FromText = "From: "
CClist = ""
BCClist = ""
Attachment = ""

* open two channels (0=POP3 an 1=SMTP).
Code = seeAttach(2, SEE_KEY_CODE)
if Code < 0
  ? "Cannot attach SEE (check SEE_KEY_CODE)"
  return
endif
Code = seeStringParam(0,SEE_LOG_FILE, Pop3File)
Code = seeStringParam(1,SEE_LOG_FILE, SmtpFile)
* connect to POP3 server on channel 0
? "Connecting to POP3 server ", Pop3Server
Code = seePop3Connect(0,Pop3Server, Pop3UserName, Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = seeErrorText(0,Code,Temp,128)
  ? Left(Temp,Code)
  Code = seeRelease()
  return
endif
* connect to SMTP server on channel 1
? "Connecting to SMTP server ", SmtpServer
Code = seeSmtpConnect(1,SmtpServer,SmtpFrom,SmtpFrom)
if Code < 0
  Temp = SPACE(128)
  Code = seeErrorText(1,Code,Temp,128)
  ? Left(Temp,Code)
  Code = seeRelease()
  return
endif
* get # messages waiting (channel 0)
? "Getting message status..."
NbrMsg = seeGetEmailCount(0)
if NbrMsg < 0
  Temp = SPACE(128)
  Code = seeErrorText(0,NbrMsg,Temp,128)
  ? Left(Temp,Code)
  Closeup()
  return
endif
? NbrMsg," messages waiting."
for I = 1 to NbrMsg
  ? "----- Message ", LTRIM(STR(I)) + " -----"
  Buffer = SPACE(5000)
  Code = seeGetEmailLines(0, I, 0, Buffer, 5000)
  if Code < 0
    Temp = SPACE(128)
    Code = seeErrorText(0,Code,Buffer,128)
    ? Left(Buffer,Code)
    Closeup()
    return
  endif
  if Code > 0
    * search for "Reply-To: " line
    Temp = SPACE(255)
    N = seeExtractText(Buffer, ReplyToText, Temp, 255)
    if N = 0
      * search for "From: " line
      N = seeExtractText(Buffer, FromText, Temp, 255)
    endif
    if N = 0 
      ? "Can't find 'Reply-To:' or 'From:'"
      return
    endif
    Temp = Left(Temp, N)
    ? Temp
    * extract return address
    Pos = AT(":", Temp)
    if Pos = 0
      ? "Missing ':' in 'From' or 'ReplyTo' header"
      Closeup()
      return
    endif
    Temp = LTRIM(SUBSTR(Temp, Pos+1))
    * isolate return address
    Pos = AT(Chr(13), Temp)
    if Pos > 1
      Temp = LEFT(Temp, Pos-1)
    endif
    if AT("<", Temp) = 0
      SmtpTo = "<" + Temp + ">"
    else
      SmtpTo = Temp
    endif
    ***? "["+SmtpTo+"]"
    * send email message
    ? "Sending response to " + SmtpTo
    Code = seeSendEmail(1,SmtpTo,CClist,BCClist,Subject,Message,Attachment)
    if Code < 0
      Buffer = SPACE(128)
      Code = seeErrorText(1,Code,Buffer,128)
      ? Left(Buffer,Code)
      Closeup()
      return
    endif
  endif
endfor
? "----- END -----"
Closeup()
return

* close both channels

Function Closeup
Private Code
Code = seeClose(0)
Code = seeClose(1)
Code = seeRelease()
return
